*Read text file with data on 20 EU countries
infile country ind hedscore age female income eduyrs using "hedonism.txt", clear

*Sort by country
sort country

*Recode numeric missing value codes to system missing
replace age=. if age==999
replace female=. if female==9
replace income=. if income==99
replace eduyrs=. if eduyrs==99

*Variance components model, i.e. with no predictors (Section 12.3)

*Note that the level 2 variance estimate differs slightly from that given in the book
*Estimates in the book obtained using restricted iterative least squares (RIGLS) in MLwiN
*Can obtain very similar estimates in Stata using the reml (restricted maximum likelihood) option 
*in place of the default mle (maximum likelihood estimation)
*RIGLS and REML are often used when the level 2 sample size is small

mixed hedscore || country: 

*Random intercept model with age (Section 12.4)

mixed hedscore age || country: 

*Random slope model with age (Section 12.5)

mixed hedscore age || country: age, cov(unstructured) 

*Within and Between Country Relationships between Hedonism and Income: Contextual Effects (Section 12.6)

*Random intercept model with income

mixed hedscore income || country: 

*Compute country-level mean income and add as predictor

by country: egen incav=mean(income)
mixed hedscore income incav || country: 

*Replace individual income by difference between individual's income and country mean income

gen incdiff=income-incav
mixed hedscore incdiff incav || country: 

